from setuptools import setup, find_packages
import os

version = '1.5'

tests_require = [
    'nose',
    'Mocker',
    'coverage',
]

setup(
    name='sixfeetup.todo',
    version=version,
    description="Python wrapper to the Six Feet Up ToDo system in Trac",
    long_description=open("README.txt").read() + "\n" +
                     open(os.path.join("docs", "HISTORY.txt")).read(),
    classifiers=[
      "Programming Language :: Python",
    ],
    keywords='trac xml-rpc todo',
    author='Clayton Parker',
    author_email='clayton@sixfeetup.com',
    url='http://sixfeetup.com',
    license='GPL',
    packages=find_packages(exclude=['ez_setup']),
    namespace_packages=['sixfeetup'],
    include_package_data=True,
    zip_safe=False,
    tests_require=tests_require,
    test_suite="nose.collector",
    install_requires=[
        'setuptools',
        'keyring<=0.2',
        'argparse',
    ], # + tests_require,
    entry_points="""
    [console_scripts]
    update_todo = sixfeetup.todo.core:main
    """,
    )
