from nose import tools
from sixfeetup.todo.ticket import Ticket

def ticket_repr_test():
    ticket = Ticket(
        10,
        "This is a todo item",
        "Week of 06/21/10",
        "Blocker",
        "1"
        )
    tools.assert_equal(
        ticket.__repr__(),
        "<Ticket #10>"
        )


def list_tickets_sort_test():
    tickets = []
    ta = tickets.append
    ta(Ticket(55, "This is a todo item", "Week of 06/28/10", "blocker", "01-Monday"))
    ta(Ticket(5, "Done by friday", "Week of 06/21/10", "blocker", "01-Monday"))
    ta(Ticket(7, "This is a todo item", "Ongoing", "critical", "04-Thursday"))
    ta(Ticket(10, "Done monday first", "Week of 06/21/10", "critical", "03-Wednesday"))
    ta(Ticket(99, "This would be first", "Week of 06/21/10", "major", "01-Monday"))
    ta(Ticket(9, "Last for week of the 21st", "Week of 06/21/10", "minor", "02-Tuesday"))
    ta(Ticket(88, "Done monday 2nd", "Week of 06/21/10", "trivial", "01-Monday"))
    # they are in the order we added them as
    tools.assert_equal(
        repr(tickets),
        '[<Ticket #55>, <Ticket #5>, <Ticket #7>, <Ticket #10>, <Ticket #99>, <Ticket #9>, <Ticket #88>]',
        "You messed up the sort order"
    )
    # now let's sort and test
    tickets.sort()
    tools.assert_equal(
        repr(tickets),
        '[<Ticket #5>, <Ticket #99>, <Ticket #88>, <Ticket #9>, <Ticket #10>, <Ticket #55>, <Ticket #7>]',
        "Order is not applying to the list properly: %s" % tickets
    )

def compare_milestone_test():
    ticket1 = Ticket(
        88,
        "Done monday 2nd",
        "Week of 06/21/10",
        "Monday",
        "10",
        )
    ticket2 = Ticket(
        88,
        "Done monday 2nd",
        "Week of 06/28/10",
        "Monday",
        "10",
        )
    ticket3 = Ticket(
        88,
        "Done monday 2nd",
        "Ongoing Work",
        "Monday",
        "10",
        )
    ticket4 = Ticket(
        88,
        "Done monday 2nd",
        "Alphabet",
        "Monday",
        "10",
        )
    # 6/21 v. 6/28
    tools.assert_equal(-1, cmp(ticket1, ticket2))
    # 6/28 v. Ongoing
    tools.assert_equal(-1, cmp(ticket2, ticket3))
    # Ongoing v. Alpha
    tools.assert_equal(1, cmp(ticket3, ticket4))

def compare_flag_test():
    """This test is kind of pointless now.
    """
    ticket1 = Ticket(
        88,
        "Summary",
        "Moot",
        "Moot",
        "01-Monday",
        )
    ticket2 = Ticket(
        88,
        "Summary",
        "Moot",
        "Moot",
        "02-Tuesday",
        )
    ticket3 = Ticket(
        88,
        "Summary",
        "Moot",
        "Moot",
        "03-Wednesday",
        )
    ticket4 = Ticket(
        88,
        "Summary",
        "Moot",
        "Moot",
        "04-Thursday",
        )
    # Monday vs. Tuesday
    tools.assert_equal(-1, cmp(ticket1, ticket2))
    # Thursday vs. Monday
    tools.assert_equal(1, cmp(ticket4, ticket1))
    # Wednesday vs. Thursday
    tools.assert_equal(-1, cmp(ticket3, ticket4))

def compare_priority_test():
    """This test is only working because the priorities work
    alphabetically
    """
    ticket1 = Ticket(
        88,
        "Summary",
        "Moot",
        "trivial",
        "10",
        )
    ticket2 = Ticket(
        88,
        "Summary",
        "Moot",
        "blocker",
        "10",
        )
    ticket3 = Ticket(
        88,
        "Summary",
        "Moot",
        "minor",
        "10",
        )
    ticket4 = Ticket(
        88,
        "Summary",
        "Moot",
        "major",
        "10",
        )
    ticket5 = Ticket(
        88,
        "Summary",
        "Moot",
        "critical",
        "10",
        )
    # trivial v. blocker
    tools.assert_equal(1, cmp(ticket1, ticket2))
    # blocker vs. minor
    tools.assert_equal(-1, cmp(ticket2, ticket3))
    # trivial vs. major
    tools.assert_equal(1, cmp(ticket1, ticket4))
    # major vs. critical
    tools.assert_equal(1, cmp(ticket4, ticket5))
